uses CRT,DOS;

type tChunkHeader=record
      Name:array[0..3] of char;Size:longint
     end;
     tWaveFormatex=record
      wFormatTag,nChannels:word;
      nSamplesPerSec,nAvgBytesPerSec:longint;
      nBlockAlign,wBitsPerSample:word
     end;

const ROMTop=longint($FFFF);ROMBlockSize=128;
      ProgressStep=(ROMTop+1) div 64;
      Base=$378;P_OUT=Base;P_IN=Base+1;
      SCLOutMask=$20;SCLInMask=$80;
      SDAOutMask=$40;SDAInMask=$40;
      ResType:string[4]='****';
      DataFound:boolean=false;

var I,DataStart,ErrCount:longint;NoErr:boolean;
    B,St,OldTextAttr:byte;Wav:file of byte;
    ChunkHeader:tChunkHeader;
    AChunkHeader:array[0..SizeOf(tChunkHeader)-1]
     of byte absolute ChunkHeader;
    WaveFormatEx:tWaveFormatEx;
    AWaveFormatex:array[0..SizeOf(tWaveFormatex)-1]
     of byte absolute WaveFormatex;

procedure SetSCL;
begin St:=St and not SCLOutMask;port[P_Out]:=St end;

procedure ResetSCL;
begin St:=St or SCLOutMask;port[P_Out]:=St end;

procedure PutSDA(B:boolean);
begin
 if B then St:=St and not SDAOutMask
      else St:=St or SDAOutMask;
 port[P_Out]:=St
end;

function GetSDA:boolean;
begin GetSDA:=(port[P_In] and SDAInMask)=0 end;

procedure InitBus;
begin
 St:=byte(not(SDAOutMask or SCLOutMask));
 port[P_Out]:=St
end;

procedure Wait;
begin asm NOP;NOP;NOP;NOP end end;

procedure Start;
begin
 SetSCL;Wait;PutSDA(false);Wait;ResetSCL;Wait
end;

procedure Stop;
begin
 PutSDA(false);Wait;SetSCL;Wait;PutSDA(true);Wait
end;

procedure PulseSCL;
begin Wait;SetSCL;Wait;ResetSCL end;

function GetBit:boolean;
begin Wait;SetSCL;Wait;GetBit:=GetSDA;ResetSCL end;

function SendByte(B:byte):boolean;
var M:byte;
begin
 M:=$80;
 repeat
  PutSDA((B and M)<>0);PulseSCL;M:=M shr 1;
 until M=0;
 PutSDA(true);SendByte:=not GetBit
end;

function GetByte:byte;
var B:byte;I:integer;
begin
 B:=0;
 for I:=0 to 7 do begin
  B:=B shl 1;if GetBit then B:=B or 1
 end;
 GetByte:=B;PutSDA(false);PulseSCL;PutSDA(true);
end;
begin
 if ParamCount=0 then begin
  WriteLn('室 ࠬ -  WAV-䠩');
  Halt
 end;
 OldTextAttr:=TextAttr;ClrScr;WriteLn;
 assign(Wav,Paramstr(1));reset(Wav);
 WriteLn(' ',FileRec(Wav).Name);
 fillchar(ChunkHeader,SizeOf(ChunkHeader),0);
 repeat
  move(AChunkHeader[1],AChunkHeader[0],
   SizeOf(AChunkHeader));
  Read(Wav,AChunkHeader[SizeOf(AChunkHeader)-1]);
  if ChunkHeader.Name='RIFF' then begin
   for I:=1 to 4 do Read(Wav,byte(ResType[I]));
   Write('',#32:21);
   if ResType<>'WAVE' then TextAttr:=LightRed+Blink;
   WriteLn(ResType);TextAttr:=OldTextAttr;
  end;
  if ChunkHeader.Name='fmt'#32 then begin
   fillchar(WaveFormatEx,SizeOf(WaveFormatex),0);
   I:=0;
   repeat
    read(Wav,AWaveFormatEx[I]);inc(I);
   until EOF(Wav) or (I>=ChunkHeader.Size)
    or (I>=Sizeof(WaveFormatEx));
   with WaveFormatEx do begin
    Write('ଠ',#32:18);
    if wFormatTag=1 then WriteLn('')
    else begin
      TextAttr:=LightRed+Blink;
      WriteLn(wFormatTag);TextAttr:=OldTextAttr;
     end;
    WriteLn('',#32:17,nChannels);
    WriteLn(' ⮢',#32:5,
     nSamplesPerSec,' ');
    WriteLn('來',#32:13,wBitsPerSample)
   end
  end;
  if ChunkHeader.Name='data' then begin
   dec(ChunkHeader.Size,8);DataFound:=true;
   WriteLn('ᥣ ⮢',#32:10,
    ChunkHeader.Size div WaveFormatEx.nBlockAlign);
   WriteLn('⥫쭮 砭',#32:3,
    ChunkHeader.Size/
    WaveFormatEx.nAvgBytesPerSec:-10:3,' ')
  end;
 until DataFound or EOF(Wav);
 if EOF(Wav) then begin Close(Wav);halt end; 
 DataStart:=FilePos(Wav);
 WriteLn('ꥬ ',#32:14,(ROMTop+1)/
  WaveFormatEx.nAvgBytesPerSec:-10:3,' ');
 WriteLn('   (Y/N)? ');
 if not (ReadKey in ['Y','y','','']) then begin
  WriteLn('');Close(Wav);halt
 end;
 TextAttr:=16*Blue+Yellow;Write(#32:64,#13);
 InitBus;for I:=1 to 9 do PulseSCL;SetSCL;
 for I:=0 to ROMTop do begin
  if (I mod ROMBlockSize)=0 then begin
   Stop;Delay(100);Start;
   SendByte($A0);SendByte(Hi(I));SendByte(Lo(I))
  end;
  if I<ChunkHeader.Size then Read(Wav,B) else B:=$80;
  SendByte(B);
  if (I mod ProgressStep)=(ProgressStep-1)
  then Write(#176)
 end;
 Write(#13);TextAttr:=OldTextAttr;
 ErrCount:=0;NoErr:=true;Seek(WAV,DataStart);
 Stop;Delay(100);Start;SendByte($A0);
 SendByte(0);SendByte(0);Start;SendByte($A1);
 for I:=0 to ROMTop do begin
  if I<ChunkHeader.Size then Read(WAV,B) else B:=$80;
  if B<>GetByte then begin
   TextAttr:=16*Red;
   inc(ErrCount);
  end;
  if (I mod ProgressStep)=(ProgressStep-1) then begin
   Write(#32);TextAttr:=16*Blue
  end
 end;
 Close(Wav);TextAttr:=OldTextAttr;
 WriteLn;WriteLn('訡',#32:18,ErrCount);
 Write(' ENTER');ReadLn;
end.
